#!/bin/sh

# Copyright \251 2004 Sun Microsystems, Inc. All rights reserved.
#
# Sun Microsystems, Inc. has intellectual property rights relating to
# technology embodied in the product that is described in this document.
# In particular, and without limitation, these intellectual property rights
# may include one or more of the U.S. patents listed at
# http://www.sun.com/patents and one or more additional patents or pending
# patent applications in the U.S. and in other countries.
#
# U.S. Government Rights - Commercial software. Government users are subject
# to the Sun Microsystems, Inc. standard license agreement and applicable
# provisions of the FAR and its supplements.
#
# Use is subject to license terms.
#
# This distribution may include materials developed by third parties. Sun,
# Sun Microsystems, the Sun logo, Java and Sun[tm] ONE are trademarks or
# registered trademarks of Sun Microsystems, Inc. in the U.S. and other
# countries.
#
# Copyright \251 2004 Sun Microsystems, Inc. Tous droits r\351serv\351s. Sun
# Microsystems, Inc. d\351tient les droits de propri\351t\351 intellectuels relatifs
# \340 la technologie incorpor\351e dans le produit qui est d\351crit dans ce document.
# En particulier, et ce sans limitation, ces droits de propri\351t\351
# intellectuelle peuvent inclure un ou plus des brevets am\351ricains list\351s
# \340 l'adresse http://www.sun.com/patents et un ou les brevets suppl\351mentaires
# ou les applications de brevet en attente aux Etats - Unis et dans les
# autres pays.
#
# L'utilisation est soumise aux termes du contrat de licence.
#
# Cette distribution peut comprendre des composants d\351velopp\351s par des
# tierces parties.
#
# Sun, Sun Microsystems, le logo Sun, Java et Sun[tm] ONE sont des marques
# de fabrique ou des marques d\351pos\351es de Sun Microsystems, Inc. aux
# Etats-Unis et dans d'autres pays.


SVC_SCRIPTS_DIR=${SERVICE_DIR}/${SVC_TO_IMPORT}/${SERVICE_VERSION_DIR}

## SEARCH FOR MSISDN module if already loaded 
tmp=`${PKGDIR}/bin/ldapsearch -B -h "$DS_HOST" -p "$DS_PORT" \
            -b "ou=iPlanetAMAuthMSISDNService,ou=services,$ROOT_SUFFIX" \
            -D "$AMADMIN_DN" -w "$ADMINPASSWD" \
            "(objectclass=*)" sunserviceschema 2>&1`
    MSISDN__EXISTS=`$ECHO $tmp | $GREP -i "no such object"`

if [ "$MSISDN_EXISTS" = "" ]; then
    $ECHO "Does not exist proceed.."
else
    $ECHO "Exists check if its the sample"
    $ADMIN_CLI --runasdn "$AMADMIN_DN" -w "$ADMINPASSWD" -t ${SVC_SCRIPTS_DIR}/msisdn_test.xml 
    if [ $? -eq 0 ]; then
        ## this is the old sample service remove it
	$ADMIN_CLI --runasdn "$AMADMIN_DN" -w "$ADMINPASSWD" -c -r iPlanetAMAuthMSISDNService 
    fi
fi
